package libpadeldescriptor;

import java.util.HashMap;
import java.util.Map;

public class AtomConstants
{
    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg1-11
    public static final double[] masses = {
                                        Double.NaN,
                                        1.008,
                                        4.002602,
                                        6.94,
                                        9.012182,
                                        10.81,
                                        12.011,
                                        14.007,
                                        15.999,
                                        18.9984032,
                                        20.1797,
                                        22.98976928,
                                        24.3050,
                                        26.9815386,
                                        28.085,
                                        30.973762,
                                        32.06,
                                        35.45,
                                        39.948,
                                        39.0983,
                                        40.078,
                                        44.955912,
                                        47.867,
                                        50.9415,
                                        51.9961,
                                        54.938045,
                                        55.845,
                                        58.933195,
                                        58.6934,
                                        63.546,
                                        65.38,
                                        69.723,
                                        72.63,
                                        74.92160,
                                        78.96,
                                        79.904,
                                        83.798,
                                        85.4678,
                                        87.62,
                                        88.90585,
                                        91.224,
                                        92.90638,
                                        95.96,
                                        98,
                                        101.07,
                                        102.90550,
                                        106.42,
                                        107.8682,
                                        112.411,
                                        114.818,
                                        118.710,
                                        121.760,
                                        127.60,
                                        126.90447,
                                        131.293,
                                        132.9054519,
                                        137.327,
                                        138.90547,
                                        140.116,
                                        140.90765,
                                        144.242,
                                        145,
                                        150.36,
                                        151.964,
                                        157.25,
                                        158.92535,
                                        162.500,
                                        164.93032,
                                        167.259,
                                        168.93421,
                                        173.054,
                                        174.9668,
                                        178.49,
                                        180.94788,
                                        183.84,
                                        186.207,
                                        190.23,
                                        192.217,
                                        195.084,
                                        196.966569,
                                        200.59,
                                        204.38,
                                        207.2,
                                        208.98040,
                                        210,
                                        210,
                                        222,
                                        223,
                                        226,
                                        227,
                                        232.03806,
                                        231.03588,
                                        238.02891,
                                        237,
                                        244,
                                        243,
                                        247,
                                        247,
                                        251,
                                        252,
                                        257,
                                        258,
                                        259,
                                        262,
                                        261,
                                        262,
                                        266,
                                        264,
                                        269,
                                        268,
                                        271
                                    };
    
    public static final int[] period = {
                                        0,
                                        1,
                                        1,
                                        2,
                                        2,
                                        2,
                                        2,
                                        2,
                                        2,
                                        2,
                                        2,
                                        3,
                                        3,
                                        3,
                                        3,
                                        3,
                                        3,
                                        3,
                                        3,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        4,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        5,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        6,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7,
                                        7
                                    };

    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg9-49
    public static final double[] volumes = {
                                            Double.NaN,
                                            4.0/3.0*Math.PI*Math.pow(1.10, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.40, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.82, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.53, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.92, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.70, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.55, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.52, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.47, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.54, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.27, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.73, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.84, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.10, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.80, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.80, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.75, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.88, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.75, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.31, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.15, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.11, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.07, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.06, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.05, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.04, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.00, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.97, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.96, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.01, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.87, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.11, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.85, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.90, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.85, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.02, 3),
                                            4.0/3.0*Math.PI*Math.pow(3.03, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.49, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.32, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.23, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.18, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.17, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.16, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.13, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.10, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.10, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.11, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.18, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.93, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.17, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.06, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.06, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.98, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.16, 3),
                                            4.0/3.0*Math.PI*Math.pow(3.43, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.68, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.43, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.42, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.40, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.39, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.38, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.36, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.35, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.34, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.33, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.31, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.30, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.29, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.27, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.26, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.24, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.23, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.22, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.18, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.16, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.16, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.13, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.13, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.14, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.23, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.96, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.02, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.07, 3),
                                            4.0/3.0*Math.PI*Math.pow(1.97, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.02, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.20, 3),
                                            4.0/3.0*Math.PI*Math.pow(3.48, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.83, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.47, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.45, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.43, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.41, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.39, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.43, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.44, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.45, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.44, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.45, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.45, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.45, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.46, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.46, 3),
                                            4.0/3.0*Math.PI*Math.pow(2.46, 3)
                                       };

    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg9-97
    public static final double[] paulingelnegativities = {
                                                        Double.NaN,
                                                        2.20,
                                                        Double.NaN,
                                                        0.98,
                                                        1.57,
                                                        2.04,
                                                        2.55,
                                                        3.04,
                                                        3.44,
                                                        3.98,
                                                        Double.NaN,
                                                        0.93,
                                                        1.31,
                                                        1.61,
                                                        1.90,
                                                        2.19,
                                                        2.58,
                                                        3.16,
                                                        Double.NaN,
                                                        0.82,
                                                        1.00,
                                                        1.36,
                                                        1.54,
                                                        1.63,
                                                        1.66,
                                                        1.55,
                                                        1.83,
                                                        1.88,
                                                        1.91,
                                                        1.90,
                                                        1.65,
                                                        1.81,
                                                        2.01,
                                                        2.18,
                                                        2.55,
                                                        2.96,
                                                        Double.NaN,
                                                        0.82,
                                                        0.95,
                                                        1.22,
                                                        1.33,
                                                        1.6,
                                                        2.13,
                                                        2.10,
                                                        2.2,
                                                        2.28,
                                                        2.20,
                                                        1.93,
                                                        1.69,
                                                        1.78,
                                                        1.96,
                                                        2.05,
                                                        2.1,
                                                        2.66,
                                                        2.60,
                                                        0.79,
                                                        0.89,
                                                        1.10,
                                                        1.12,
                                                        1.13,
                                                        1.14,
                                                        Double.NaN,
                                                        1.17,
                                                        Double.NaN,
                                                        1.20,
                                                        Double.NaN,
                                                        1.22,
                                                        1.23,
                                                        1.24,
                                                        1.25,
                                                        Double.NaN,
                                                        1.0,
                                                        1.3,
                                                        1.5,
                                                        1.7,
                                                        1.9,
                                                        2.2,
                                                        2.2,
                                                        2.2,
                                                        2.4,
                                                        1.9,
                                                        1.8,
                                                        1.8,
                                                        1.9,
                                                        2.0,
                                                        2.2,
                                                        Double.NaN,
                                                        0.7,
                                                        0.9,
                                                        1.1,
                                                        1.3,
                                                        1.5,
                                                        1.7,
                                                        1.3,
                                                        1.3
                                                    };

    // From Sanderson, RT. Electronegativity and Bond Energy. J. Am. Chem. Soc. 1983, 105: 2259-2261. Remaining values come from http://www.talete.mi.it/help/dragon_help/weighting_schemes.htm
    public static final double[] sandersonelnegativities = {
                                                        Double.NaN,
                                                        2.592,
                                                        Double.NaN,
                                                        0.670,
                                                        1.810,
                                                        2.275,
                                                        2.746,
                                                        3.194,
                                                        3.654,
                                                        4.000,
                                                        4.5,
                                                        0.560,
                                                        1.318,
                                                        1.714,
                                                        2.138,
                                                        2.515,
                                                        2.957,
                                                        3.475,
                                                        3.31,
                                                        0.445,
                                                        0.946,
                                                        1.02,
                                                        1.09,
                                                        1.39,
                                                        1.66,
                                                        2.2,
                                                        2.2,
                                                        2.56,
                                                        1.94,
                                                        2.033,
                                                        2.223,
                                                        2.419,
                                                        2.618,
                                                        2.816,
                                                        3.014,
                                                        3.219,
                                                        2.91,
                                                        0.312,
                                                        0.721,
                                                        0.65,
                                                        0.9,
                                                        1.42,
                                                        1.15,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        1.826,
                                                        1.978,
                                                        2.138,
                                                        2.298,
                                                        2.458,
                                                        2.618,
                                                        2.778,
                                                        2.34,
                                                        0.220,
                                                        0.651,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        0.98,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        Double.NaN,
                                                        2.195,
                                                        2.246,
                                                        2.291,
                                                        2.342
                                                   };

    // From http://www.chm.davidson.edu/ronutt/che115/electroneg.htm
    public static final double[] allredrochowelnegativities = {
                                                            Double.NaN,
                                                            2.20,
                                                            Double.NaN,
                                                            0.97,
                                                            1.47,
                                                            2.01,
                                                            2.50,
                                                            3.07,
                                                            3.50,
                                                            4.10,
                                                            Double.NaN,
                                                            1.01,
                                                            1.23,
                                                            1.47,
                                                            1.74,
                                                            2.06,
                                                            2.44,
                                                            2.83,
                                                            Double.NaN,
                                                            0.91,
                                                            1.04,
                                                            1.20,
                                                            1.32,
                                                            1.45,
                                                            1.56,
                                                            1.60,
                                                            1.64,
                                                            1.70,
                                                            1.75,
                                                            1.75,
                                                            1.66,
                                                            1.82,
                                                            2.02,
                                                            2.20,
                                                            2.48,
                                                            2.74,
                                                            Double.NaN,
                                                            0.89,
                                                            0.99,
                                                            1.11,
                                                            1.22,
                                                            1.23,
                                                            1.30,
                                                            1.36,
                                                            1.42,
                                                            1.45,
                                                            1.35,
                                                            1.42,
                                                            1.46,
                                                            1.49,
                                                            1.72,
                                                            1.82,
                                                            2.01,
                                                            2.21,
                                                            Double.NaN,
                                                            0.86,
                                                            0.97,
                                                            1.08,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            Double.NaN,
                                                            1.23,
                                                            1.33,
                                                            1.40,
                                                            1.46,
                                                            1.52,
                                                            1.55,
                                                            1.44,
                                                            1.42,
                                                            1.44,
                                                            1.44,
                                                            1.55,
                                                            1.67,
                                                            1.76,
                                                            1.90
                                                        };
    
    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg10-188
    public static final double[] polarizabilities = {
                                                    Double.NaN,
                                                    0.666793,
                                                    0.2050522,
                                                    24.33,
                                                    5.60,
                                                    3.03,
                                                    1.67,
                                                    1.10,
                                                    0.802,
                                                    0.557,
                                                    0.39432,
                                                    24.11,
                                                    10.6,
                                                    6.8,
                                                    5.53,
                                                    3.63,
                                                    2.90,
                                                    2.18,
                                                    1.6411,
                                                    43.06,
                                                    22.8,
                                                    17.8,
                                                    14.6,
                                                    12.4,
                                                    11.6,
                                                    9.4,
                                                    8.4,
                                                    7.5,
                                                    6.8,
                                                    6.2,
                                                    5.75,
                                                    8.12,
                                                    5.84,
                                                    4.31,
                                                    3.77,
                                                    3.05,
                                                    2.4844,
                                                    47.24,
                                                    23.5,
                                                    22.7,
                                                    17.9,
                                                    15.7,
                                                    12.8,
                                                    11.4,
                                                    9.6,
                                                    8.6,
                                                    4.8,
                                                    6.78,
                                                    7.36,
                                                    10.2,
                                                    7.84,
                                                    6.6,
                                                    5.5,
                                                    5.35,
                                                    4.044,
                                                    59.42,
                                                    39.7,
                                                    31.1,
                                                    29.6,
                                                    28.2,
                                                    31.4,
                                                    30.1,
                                                    28.8,
                                                    27.7,
                                                    23.5,
                                                    25.5,
                                                    24.5,
                                                    23.6,
                                                    22.7,
                                                    21.8,
                                                    20.9,
                                                    21.9,
                                                    16.2,
                                                    13.1,
                                                    11.1,
                                                    9.7,
                                                    8.5,
                                                    7.6,
                                                    6.5,
                                                    5.8,
                                                    5.02,
                                                    7.6,
                                                    7.01,
                                                    7.4,
                                                    6.8,
                                                    6.0,
                                                    5.3,
                                                    48.6,
                                                    38.3,
                                                    32.1,
                                                    32.1,
                                                    25.4,
                                                    24.9,
                                                    24.8,
                                                    24.5,
                                                    23.3,
                                                    23.0,
                                                    22.7,
                                                    20.5,
                                                    19.7,
                                                    23.8,
                                                    18.2,
                                                    16.4,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    4.06,
                                                    Double.NaN,
                                                    4.59,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    Double.NaN,
                                                    24.26
                                                };
    
    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg10-197
    public static final double[] ionpotentials = {
                                                Double.NaN,
                                                13.598443,
                                                24.587387,
                                                5.391719,
                                                9.32270,
                                                8.29802,
                                                11.26030,
                                                14.5341,
                                                13.61805,
                                                17.4228,
                                                21.56454,
                                                5.139076,
                                                7.646235,
                                                5.985768,
                                                8.15168,
                                                10.48669,
                                                10.36001,
                                                12.96763,
                                                15.759610,
                                                4.3406633,
                                                6.11316,
                                                6.56149,
                                                6.82812,
                                                6.74619,
                                                6.76651,
                                                7.43402,
                                                7.9024,
                                                7.88101,
                                                7.6398,
                                                7.72638,
                                                9.394199,
                                                5.999301,
                                                7.89943,
                                                9.7886,
                                                9.75239,
                                                11.8138,
                                                13.99961,
                                                4.177128,
                                                5.69485,
                                                6.2173,
                                                6.63390,
                                                6.75885,
                                                7.09243,
                                                7.28,
                                                7.36050,
                                                7.45890,
                                                8.3369,
                                                7.57623,
                                                8.99382,
                                                5.78636,
                                                7.34392,
                                                8.60839,
                                                9.0096,
                                                10.45126,
                                                12.12984,
                                                3.893905,
                                                5.211664,
                                                5.5769,
                                                5.5387,
                                                5.473,
                                                5.5250,
                                                5.582,
                                                5.6437,
                                                5.67038,
                                                6.14980,
                                                5.8638,
                                                5.9389,
                                                6.0215,
                                                6.1077,
                                                6.18431,
                                                6.25416,
                                                5.42586,
                                                6.82507,
                                                7.54957,
                                                7.86403,
                                                7.83352,
                                                8.43823,
                                                8.96702,
                                                8.9588,
                                                9.22553,
                                                10.4375,
                                                6.108194,
                                                7.41663,
                                                7.2855,
                                                8.414,
                                                Double.NaN,
                                                10.7485,
                                                4.072741,
                                                5.278423,
                                                5.17,
                                                6.3067,
                                                5.89,
                                                6.1941,
                                                6.2657,
                                                6.0260,
                                                5.9738,
                                                5.9914,
                                                6.1979,
                                                6.2817,
                                                6.42,
                                                6.50,
                                                6.58,
                                                6.65,
                                                4.9,
                                                6.0
                                             };

    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg9-49
    public static final double[] radius_vdw = {
                                            Double.NaN,
                                            1.1,
                                            1.4,
                                            1.82,
                                            1.53,
                                            1.92,
                                            1.7,
                                            1.55,
                                            1.52,
                                            1.47,
                                            1.54,
                                            2.27,
                                            1.73,
                                            1.84,
                                            2.1,
                                            1.8,
                                            1.8,
                                            1.75,
                                            1.88,
                                            2.75,
                                            2.31,
                                            2.15,
                                            2.11,
                                            2.07,
                                            2.06,
                                            2.05,
                                            2.04,
                                            2,
                                            1.97,
                                            1.96,
                                            2.01,
                                            1.87,
                                            2.11,
                                            1.85,
                                            1.9,
                                            1.85,
                                            2.02,
                                            3.03,
                                            2.49,
                                            2.32,
                                            2.23,
                                            2.18,
                                            2.17,
                                            2.16,
                                            2.13,
                                            2.1,
                                            2.1,
                                            2.11,
                                            2.18,
                                            1.93,
                                            2.17,
                                            2.06,
                                            2.06,
                                            1.98,
                                            2.16,
                                            3.43,
                                            2.68,
                                            2.43,
                                            2.42,
                                            2.4,
                                            2.39,
                                            2.38,
                                            2.36,
                                            2.35,
                                            2.34,
                                            2.33,
                                            2.31,
                                            2.3,
                                            2.29,
                                            2.27,
                                            2.26,
                                            2.24,
                                            2.23,
                                            2.22,
                                            2.18,
                                            2.16,
                                            2.16,
                                            2.13,
                                            2.13,
                                            2.14,
                                            2.23,
                                            1.96,
                                            2.02,
                                            2.07,
                                            1.97,
                                            2.02,
                                            2.2,
                                            3.48,
                                            2.83,
                                            2.47,
                                            2.45,
                                            2.43,
                                            2.41,
                                            2.39,
                                            2.43,
                                            2.44,
                                            2.45,
                                            2.44,
                                            2.45,
                                            2.45,
                                            2.45,
                                            2.46,
                                            2.46,
                                            2.46
                                       };
    
    // From Handbook of Chemistry and Physics, 94th Edition, 2013-2014, pg9-49
    public static final double[] radius_covalent = {
                                                Double.NaN,
                                                0.32,
                                                0.37,
                                                1.3,
                                                0.99,
                                                0.84,
                                                0.75,
                                                0.71,
                                                0.64,
                                                0.6,
                                                0.62,
                                                1.6,
                                                1.4,
                                                1.24,
                                                1.14,
                                                1.09,
                                                1.04,
                                                1,
                                                1.01,
                                                2,
                                                1.74,
                                                1.59,
                                                1.48,
                                                1.44,
                                                1.3,
                                                1.29,
                                                1.24,
                                                1.18,
                                                1.17,
                                                1.22,
                                                1.2,
                                                1.23,
                                                1.2,
                                                1.2,
                                                1.18,
                                                1.17,
                                                1.16,
                                                2.15,
                                                1.9,
                                                1.76,
                                                1.64,
                                                1.56,
                                                1.46,
                                                1.38,
                                                1.36,
                                                1.34,
                                                1.3,
                                                1.36,
                                                1.4,
                                                1.42,
                                                1.4,
                                                1.4,
                                                1.37,
                                                1.36,
                                                1.36,
                                                2.38,
                                                2.06,
                                                1.94,
                                                1.84,
                                                1.9,
                                                1.88,
                                                1.86,
                                                1.85,
                                                1.83,
                                                1.82,
                                                1.81,
                                                1.8,
                                                1.79,
                                                1.77,
                                                1.77,
                                                1.78,
                                                1.74,
                                                1.64,
                                                1.58,
                                                1.5,
                                                1.41,
                                                1.36,
                                                1.32,
                                                1.3,
                                                1.3,
                                                1.32,
                                                1.44,
                                                1.45,
                                                1.5,
                                                1.42,
                                                1.48,
                                                1.46,
                                                2.42,
                                                2.11,
                                                2.01,
                                                1.9,
                                                1.84,
                                                1.83,
                                                1.8,
                                                1.8,
                                                1.73,
                                                1.68,
                                                1.68,
                                                1.68,
                                                1.65,
                                                1.67,
                                                1.73,
                                                1.76,
                                                1.61,
                                                1.57,
                                                1.49,
                                                1.43,
                                                1.41,
                                                1.34,
                                                1.29,
                                                1.28
                                             };
    
    public static final Map<String,Integer> atomic_number = new HashMap<String,Integer>();
    static
    {
        atomic_number.put("H", 1);
        atomic_number.put("He", 2);
        atomic_number.put("Li", 3);
        atomic_number.put("Be", 4);
        atomic_number.put("B", 5);
        atomic_number.put("C", 6);
        atomic_number.put("N", 7);
        atomic_number.put("O", 8);
        atomic_number.put("F", 9);
        atomic_number.put("Ne", 10);
        atomic_number.put("Na", 11);
        atomic_number.put("Mg", 12);
        atomic_number.put("Al", 13);
        atomic_number.put("Si", 14);
        atomic_number.put("P", 15);
        atomic_number.put("S", 16);
        atomic_number.put("Cl", 17);
        atomic_number.put("Ar", 18);
        atomic_number.put("K", 19);
        atomic_number.put("Ca", 20);
        atomic_number.put("Sc", 21);
        atomic_number.put("Ti", 22);
        atomic_number.put("V", 23);
        atomic_number.put("Cr", 24);
        atomic_number.put("Mn", 25);
        atomic_number.put("Fe", 26);
        atomic_number.put("Co", 27);
        atomic_number.put("Ni", 28);
        atomic_number.put("Cu", 29);
        atomic_number.put("Zn", 30);
        atomic_number.put("Ga", 31);
        atomic_number.put("Ge", 32);
        atomic_number.put("As", 33);
        atomic_number.put("Se", 34);
        atomic_number.put("Br", 35);
        atomic_number.put("Kr", 36);
        atomic_number.put("Rb", 37);
        atomic_number.put("Sr", 38);
        atomic_number.put("Y", 39);
        atomic_number.put("Zr", 40);
        atomic_number.put("Nb", 41);
        atomic_number.put("Mo", 42);
        atomic_number.put("Tc", 43);
        atomic_number.put("Ru", 44);
        atomic_number.put("Rh", 45);
        atomic_number.put("Pd", 46);
        atomic_number.put("Ag", 47);
        atomic_number.put("Cd", 48);
        atomic_number.put("In", 49);
        atomic_number.put("Sn", 50);
        atomic_number.put("Sb", 51);
        atomic_number.put("Te", 52);
        atomic_number.put("I", 53);
        atomic_number.put("Xe", 54);
        atomic_number.put("Cs", 55);
        atomic_number.put("Ba", 56);
        atomic_number.put("La", 57);
        atomic_number.put("Ce", 58);
        atomic_number.put("Pr", 59);
        atomic_number.put("Nd", 60);
        atomic_number.put("Pm", 61);
        atomic_number.put("Sm", 62);
        atomic_number.put("Eu", 63);
        atomic_number.put("Gd", 64);
        atomic_number.put("Tb", 65);
        atomic_number.put("Dy", 66);
        atomic_number.put("Ho", 67);
        atomic_number.put("Er", 68);
        atomic_number.put("Tm", 69);
        atomic_number.put("Yb", 70);
        atomic_number.put("Lu", 71);
        atomic_number.put("Hf", 72);
        atomic_number.put("Ta", 73);
        atomic_number.put("W", 74);
        atomic_number.put("Re", 75);
        atomic_number.put("Os", 76);
        atomic_number.put("Ir", 77);
        atomic_number.put("Pt", 78);
        atomic_number.put("Au", 79);
        atomic_number.put("Hg", 80);
        atomic_number.put("Tl", 81);
        atomic_number.put("Pb", 82);
        atomic_number.put("Bi", 83);
        atomic_number.put("Po", 84);
        atomic_number.put("At", 85);
        atomic_number.put("Rn", 86);
        atomic_number.put("Fr", 87);
        atomic_number.put("Ra", 88);
        atomic_number.put("Ac", 89);
        atomic_number.put("Th", 90);
        atomic_number.put("Pa", 91);
        atomic_number.put("U", 92);
        atomic_number.put("Np", 93);
        atomic_number.put("Pu", 94);
        atomic_number.put("Am", 95);
        atomic_number.put("Cm", 96);
        atomic_number.put("Bk", 97);
        atomic_number.put("Cf", 98);
        atomic_number.put("Es", 99);
        atomic_number.put("Fm", 100);
        atomic_number.put("Md", 101);
        atomic_number.put("No", 102);
        atomic_number.put("Lr", 103);
        atomic_number.put("Rf", 104);
        atomic_number.put("Db", 105);
        atomic_number.put("Sg", 106);
        atomic_number.put("Bh", 107);
        atomic_number.put("Hs", 108);
        atomic_number.put("Mt", 109);
        atomic_number.put("Ds", 110);
        atomic_number.put("Rg", 111);
        atomic_number.put("Cn", 112);
        atomic_number.put("Uut", 113);
        atomic_number.put("Fl", 114);
        atomic_number.put("Uup", 115);
        atomic_number.put("Lv", 116);
        atomic_number.put("Uus", 117);
        atomic_number.put("Uuo", 118);
    }
}
